
| aDirectory aContext aBoolean aBlock aDialog aCollection aWorkbook aBuilder aRectangle |
aDirectory := nil.
aContext := thisContext.
aBoolean := true.
aBlock :=
		[[aContext notNil and: [aBoolean yourself]] whileTrue: 
				[(aContext selector == #fileIn and: [aContext receiver isKindOf: Stream])
					ifTrue: 
						[| aFilename |
						aFilename := aContext receiver stream fileName.
						aDirectory := aFilename head asFilename.
						aBoolean := false].
				aContext := aContext sender]].
[aBlock value]
	on: aBlock messageNotUnderstoodSignal
	do: 
		[:exception |
		aDirectory := nil.
		exception return].
aDirectory
	ifNil: 
		[aDirectory := Filename defaultDirectory construct: 'Workbook'.
		aDirectory exists
			ifFalse: 
				[aDialog := ChooseDirectoryDialog new.
				aDialog windowTitle: 'Choose the direcotry ' , aDirectory tail printString.
				aDialog open ifFalse: [^nil].
				aDirectory := aDialog selection]].
aDirectory := aDirectory construct: 'Workspaces'.
aDirectory exists ifFalse: [^nil].
aCollection := OrderedCollection new.
aDirectory directoryContents asSortedCollection
	do:
		[:each | 
		('*.st' match: each)
			ifTrue: [aCollection add: (aDirectory construct: each)]].
aWorkbook := Workbook new.
aCollection with: (1 to: aCollection size)
	do: 
		[:each :index |
		| aStream pageContents labelString aPage |
		aStream := each readStream.
		[pageContents := aStream contents] ensure: [aStream close].
		labelString := each tail asString.
		labelString := (Filename splitExtension: labelString) first.
		aPage := WorkspacePage labeled: labelString with: pageContents.
		index = 1
			ifTrue: [aWorkbook replaceAllTextPagesWith: aPage]
			ifFalse: [aWorkbook addPage: aPage]].
aBuilder := aWorkbook allButOpenInterface: #windowSpec.
aRectangle := (Screen default bounds center extent: 0 @ 0)
			expandedBy: 400 @ 250.
aBuilder window openIn: aRectangle.
aBuilder window displayPendingInvalidation.
aWorkbook postOpenWith: aBuilder.
^aWorkbook